VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FileLib"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'Origional Code by Ken Getz August 1, 1998
'MOdified by Stephen Forte August 15, 1998
'Mostly to add the Folder object
'Moved to a Class by Stephen Forte August 21, 1998

Private dctFiles As Scripting.Dictionary

'local variable(s) to hold property value(s)
Private mvarDirectory As String 'local copy
Private mvarFilter As Variant 'local copy
Public Function OpenRecordset() As ADODB.Recordset

    Dim fso As Scripting.FileSystemObject
    Dim fil As Scripting.File
    Dim fol As Scripting.Folder
    
    Set fso = New Scripting.FileSystemObject
    Set dctFiles = New Scripting.Dictionary
    
    'Set the folder to the directory passed
    'into the Class via the Directory property
    Set fol = fso.GetFolder(Me.Directory)
    
    'Loop through the files to add to the Dictionary
    For Each fil In fol.Files
        dctFiles.Add fil.ShortName, fil
    Next fil
    
    Set OpenRecordset = SortandFilter

End Function

Private Function SortandFilter() As ADODB.Recordset

    Dim rst As ADODB.Recordset
    Dim dctTemp As Scripting.Dictionary
    Dim i As Integer
    
    ' Create the temporary recordset.
    Set rst = New ADODB.Recordset
    rst.Fields.Append "ShortName", adVarChar, 12
    rst.Fields.Append "Size", adInteger
    rst.Fields.Append "Index", adSmallInt
    rst.Fields.Append "Extention", adVarChar, 3
    rst.Open
    
    ' Add all the necessary info from the
    ' dictionary to the recordset.
    For i = 0 To dctFiles.Count - 1
        rst.AddNew _
         Array("ShortName", "Size", "Index", "Extention"), _
         Array(dctFiles.Keys(i), dctFiles.Items(i).Size, i, Right$(dctFiles.Items(i).Path, 3))
    Next i
    
    ' Sort the recordset on the Size field.
    rst.Sort = "Size"
    
    ' Create a new dictionary, and then copy
    ' all the data back into the new dictionary.
    Set dctTemp = New Scripting.Dictionary
    rst.MoveFirst
    Do Until rst.EOF
        dctTemp.Add _
         dctFiles.Keys(rst!Index), _
         dctFiles.Items(rst!Index)
        rst.MoveNext
    Loop
    
    ' Set the original dictionary pointer
    ' to refer to the new dictionary. This
    ' should destroy the original dictionary,
    ' and all the data it contained.
    Set dctFiles = dctTemp
    
    'Filter the recordset
    rst.Filter = "Extention= " & Chr(39) & Me.Filter & Chr(39)
       
    Set SortandFilter = rst
    

End Function



Public Property Let Filter(ByVal vData As Variant)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Filter = 5
    mvarFilter = vData
End Property

Public Property Get Filter() As Variant
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Filter
    Filter = mvarFilter
End Property
Public Property Let Directory(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Directory = 5
    mvarDirectory = vData
End Property
Public Property Get Directory() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Directory
    Directory = mvarDirectory
End Property
