Attribute VB_Name = "basADOx"
Option Explicit

Sub CreateDBandTables_ADOx()

Dim cat As ADOX.Catalog
Dim tbl As ADOX.Table
Dim rst As ADODB.Recordset
Dim strConnect As String

'Here we create a connection string
'and point it to the new database path
'we also have to set the provider information
strConnect = "provider=Microsoft.JET.OLEDB.4.0;" & _
    "data source=" & App.Path & "\newdb.mdb"


On Error Resume Next
'Delete the Demo MDB file of it exists
Kill App.Path & "\newdb.mdb"

Set cat = New ADOX.Catalog
cat.Create strConnect

Set tbl = New ADOX.Table

'This creates the actual table in Jet 4.0
With tbl
    .Name = "Customers"
    'Here you specify the fields
    .Columns.Append "CustomerID", adInteger
    .Columns.Append "Name_Prefix", adWChar, 25
    .Columns.Append "Name_First", adWChar, 25
    .Columns.Append "Name_Last", adWChar, 50
End With

'Here you are appedning the table
'object to the current catalog
cat.Tables.Append tbl


'Append rows to the table
Set rst = New ADODB.Recordset
rst.Open "Customers", strConnect, adOpenKeyset, adLockOptimistic

With rst
    'Add a record
    .AddNew
    !CustomerID = 1
    !Name_Prefix = "Mr."
    !Name_First = "Tom"
    !Name_Last = "Howe"
    .Update
    
    'Add another record
    .AddNew
    !CustomerID = 2
    !Name_Prefix = "Ms."
    !Name_First = "Lori"
    !Name_Last = "Ash"
    .Update


.Close

End With

Set rst = Nothing

End Sub
