Attribute VB_Name = "basDataShape"
Option Explicit

Sub CubeRelation()

  Dim Recordset As ADODB.Recordset
  Set Recordset = New ADODB.Recordset

  Dim ConnectionString As String
  ConnectionString = "Provider=MSDataShape;" & _
    "data provider=Microsoft.Jet.OLEDB.4.0" & _
    ";data source=" & App.Path & "\sample.mdb"

  Recordset.Source = _
    "shape {Select * from customers where Customerid='ALFKI'} Append " & _
    "({Select * From Orders} As rsOrders " & _
    "RELATE customerid to customerid)"
        
  Recordset.Open , ConnectionString
  Set frmADO.MSHFlexGrid1.Recordset = Recordset

End Sub

Sub CubeGroupHierarchy()

  Dim ConnectionString As String
  ConnectionString = "Provider=MSDataShape;" & _
    "data provider=Microsoft.Jet.OLEDB.4.0" & _
    ";data source=" & App.Path & "\sample.mdb"

  Dim Recordset As ADODB.Recordset
  Set Recordset = New ADODB.Recordset
  
  Recordset.Source = _
    "shape {Select customerid,  Region from Customers} rst1 " & _
    "COMPUTE COUNT (rst1.customerid) AS CustCount, rst1 By Region "
        
  Recordset.Open , ConnectionString
  Set frmADO.MSHFlexGrid1.Recordset = Recordset

End Sub

Sub ShowInExcel()

  
  Dim Recordset As ADODB.Recordset
  Set Recordset = New ADODB.Recordset

  Dim ConnectionString As String
  ConnectionString = "Provider=MSDataShape" & _
    ";data provider=Microsoft.Jet.OLEDB.4.0" & _
    ";data source=C:\ sample.mdb"

  Recordset.Source = _
    "shape {Select * from customers where Customerid='ALFKI'}" & _
    " Append " & _
    "({Select * From Orders} As rsOrders " & _
    "RELATE customerid to customerid)"
        
  Recordset.ActiveConnection = ConnectionString
  Recordset.Open , , adOpenStatic, adLockBatchOptimistic

  Call ShowRecordsetInExcel(Recordset)

End Sub

Sub ShowRecordsetInExcel(ByVal Recordset As ADODB.Recordset, _
        Optional SkipClear As Boolean = False)

  Dim ChildRecordset As ADODB.Recordset
  Dim Column As ADODB.Field
  Dim CurrentColumn As Integer
  Dim CurrentRow As Integer
  
  
  If Not blnSKipClear Then
      'Clear out the cells
      Cells.Select
      Selection.ClearContents
  End If
  
  Do Until rst.EOF
     intCurrentColumn = intCurrentColumn + 1
     If Not blnSKipClear Then
          intCurrentRow = 1
      Else
          intCurrentRow = 2
      End If
      
     
     For Each col In rst.Fields
      If col.Type <> adChapter Then
  
           Cells(intCurrentColumn, intCurrentRow) = _
                  col.Name & ": " & col.Value
           
      Else
           Set rstChild = col.Value
           ShowRSTinExcel rstChild, True
        End If
        
        intCurrentRow = intCurrentRow + 1
     Next
  
     rst.MoveNext
  Loop
  
  Cells(1, 1).Select

End Sub


