Attribute VB_Name = "basRstPersistence"
Option Explicit

Sub Persist()
  
  On Error GoTo Except
  
  Dim SQL As String
  Dim Msg As String
  Dim NewValue As String
  
  
  SQL = "Select * From Customers Where CustomerID='ALFKI'"
  
  Dim Connection As ADODB.Connection
  Set Connection = New ADODB.Connection
  Connection.Provider = "Microsoft.Jet.OLEDB.3.51"
  Connection.ConnectionString = "data source=" & _
    App.Path & "\sample.mdb"
  
  Connection.Open
  
  Dim Recordset As ADODB.Recordset
  Set Recordset = New ADODB.Recordset
  
  Recordset.CursorLocation = adUseClient
  Recordset.Open SQL, _
    Connection, adOpenStatic, adLockBatchOptimistic
  
  Msg = "Please Enter in a new CompanyName for: " & _
        Recordset!CompanyName & vbNewLine & _
        "This CustomerID=" & Recordset!CustomerID
      
  NewValue = InputBox(Msg)
  
  Recordset.Update "CompanyName", NewValue
  
  On Error Resume Next
    Kill App.Path & "\hcado.dat"
  
  On Error GoTo Except
  Recordset.Save App.Path & "\hcado.dat", adPersistADTG
  
  Recordset.Close
  Set Recordset = Nothing
  
  MsgBox "Saved to: " & App.Path & "\hcado.dat", vbInformation
  
  Exit Sub
  
Except:
  MsgBox Err.Description
End Sub

Sub Resynch()
  
  On Error GoTo Except
  
  Dim SQL As String
  SQL = "Select * From Customers Where CustomerID='ALFKI'"
  
  Dim Recordset As ADODB.Recordset
  Set Recordset = New ADODB.Recordset
  
  ' Open the recordset pesisted to file
  Recordset.Open App.Path & "\hcado.dat", , adOpenStatic, adLockBatchOptimistic, adCmdFile
  
  Dim Msg As String
  Msg = "Value in DataSource: " & _
        Recordset!CompanyName.OriginalValue
        
  Msg = Msg & vbNewLine & _
    "Value on Disk           : " & Recordset!CompanyName
  
  MsgBox Msg, vbInformation, "Original Value vs Saved on Disk"
  
  Dim Connection As ADODB.Connection
  Set Connection = New ADODB.Connection
  Connection.Provider = "Microsoft.Jet.OLEDB.3.51"
  Connection.ConnectionString = "data source=" & _
              App.Path & "\sample.mdb"
  Connection.Open
  
  Recordset.ActiveConnection = Connection
  Recordset.UpdateBatch
  
  MsgBox "Database Re-Synced!", vbInformation
  
  Exit Sub
  
Except:
  MsgBox Err.Description
End Sub


Sub SimpleOpenfromFile()
  
  Dim Recordset As ADODB.Recordset
  Set Recordset = New ADODB.Recordset
  
  Recordset.Open _
    "C:\steve.dat", , adOpenStatic, adLockBatchOptimistic, adCmdFile
  
  Do Until Recordset.EOF
    Debug.Print Recordset!Name_First & " " & Recordset!Name_Last
    Recordset.MoveNext
  Loop

End Sub
