Attribute VB_Name = "basSchema"
Option Explicit
Sub UserRoster()
'This example will show you how to
'open up the user roster in Jet 4.0
'and look at all the users in the LDB File
'This replaces the need for LDBView

Dim conn As ADODB.Connection
Dim rst As ADODB.Recordset

Set conn = New ADODB.Connection

'JET 4.0 Only
With conn
    .Provider = "Microsoft.Jet.OLEDB.4.0"
    .ConnectionString = "Data source=" & App.Path & "\sample.mdb"
    .Open
End With

'For now all we have is the CLASSID for the
'Provider specific attribute:
'{947bb102-5d43-11d1-bdbf-00c04fb92675"

'Open the recordset from the OpenSchema
Set rst = conn.OpenSchema(adSchemaProviderSpecific, , _
"{947bb102-5d43-11d1-bdbf-00c04fb92675}")

'Display all the Users in the database
Do Until rst.EOF
    Debug.Print "Computer Name: " & rst!COMPUTER_NAME
    Debug.Print "Login Name: " & rst!LOGIN_NAME
    Debug.Print "Conencted: " & rst!CONNECTED
    Debug.Print "Suspect: " & rst!SUSPECTED_STATE

    rst.MoveNext
Loop

'Clean Up
rst.Close
conn.Close

Set rst = Nothing
Set conn = Nothing

End Sub
Sub ReadSchema()
'This example will show you how to
'open up a schema with a provider to
'look at all the database objects

Dim conn As ADODB.Connection
Dim rst As ADODB.Recordset

Set conn = New ADODB.Connection

'Jet
'With conn
'    .Provider = "Microsoft.Jet.OLEDB.4.0"
'    .ConnectionString = "Data source=" & App.Path & "\sample.mdb"
'    .Open
'End With

'SQL Server
With conn
    .Provider = "SQLOLEDB"
    .ConnectionString = "data source=batman;user id=sa;initial catalog=Northwind"
    .Open
End With

Set rst = conn.OpenSchema(adSchemaTables)

Do Until rst.EOF
    Debug.Print "Catalog: " & rst!Table_Catalog
    Debug.Print "Schema: " & rst!Table_Schema
    Debug.Print "Table Name: " & rst!Table_Name
    Debug.Print "Type: " & rst!Table_Type
    Debug.Print "Date Created: " & rst!Date_Created
    Debug.Print "Date Modified" & rst!Date_Modified
    Debug.Print
    
    'Move to the next item in the catalog
    rst.MoveNext
Loop

'Clean Up
rst.Close
conn.Close

Set rst = Nothing
Set conn = Nothing

End Sub

